#include <windows.h>
#include <ddraw.h>
#include <stdlib.h>
#include "include/windsoul.h"
#include "include/wscanvas.h"
#include "wppmodel.h"

HDC			hDC;
bool inited=false;

long FAR WINAPI WindowProc(HWND,UINT,WPARAM,LPARAM);

//ʼ
int init(HINSTANCE hInstance)
{
	WNDCLASS            wc;

    wc.style=          CS_HREDRAW|CS_VREDRAW;
    wc.lpfnWndProc=    WindowProc;
    wc.cbClsExtra=     0;
    wc.cbWndExtra=     0;
    wc.hInstance=      hInstance;
    wc.hIcon=          LoadIcon(hInstance,"WS_ICON");
    wc.hCursor=        LoadCursor(NULL,NULL);
    wc.hbrBackground=  NULL;
    wc.lpszMenuName=   NULL;
    wc.lpszClassName=  "WPP";
    RegisterClass(&wc);

	return 0;
} 

HWND create_window(HINSTANCE hInst)
{
    return CreateWindowEx(
        0,
        "WPP",
        "WPP",
        WS_SYSMENU|WS_MINIMIZEBOX,
		0,
		0,
		100,
		100,
        NULL,
        NULL,
        hInst,
        NULL );
}

void show_window(HWND hWnd,int width,int height,int nCmdShow)
{
	RECT rcl;
	SetRect(&rcl,0,0,width,height);

	AdjustWindowRect( &rcl,
		WS_SYSMENU | WS_CAPTION | WS_MINIMIZEBOX,
//		GetMenu( hWnd)!= NULL,
		0 );

	MoveWindow(hWnd,
        rcl.left+(GetSystemMetrics(SM_CXSCREEN)-width)/2,
        rcl.top+(GetSystemMetrics(SM_CYSCREEN)-height)/2,
		rcl.right-rcl.left,
		rcl.bottom-rcl.top,
		FALSE );

    ShowWindow(hWnd,nCmdShow);
    UpdateWindow(hWnd);
}

#define WIDTH 640
#define HEIGHT 480

GRAPH wsgraph(16);
CANVAS canvas(WIDTH,HEIGHT);
//CANVAS canvas2(320,200);
//BMP canvas2(400,300,WS_DC|16);
BMP sm;
BMP back;
BMP bmp;
BMP tile[2];
BMP stand[4][8];
BMP hero_stand;
BMP walk[4][14];
BMP hero_walk;
int fps=32;

class HERO {
	BMP *bitmaps;
	int frames;
	int f;
	int x;
	int y;
	int dis;
	int step;
public:
	HERO(BMP *bmps,int f,int x,int y) : bitmaps(bmps), frames(f), f(0), x(x), y(y), step(0) {
		dis=rand()%4;
	}
	void update();
} *npc[4];

int map[256][256];
int dis=3;
int iswalk=0;
struct {
	int x;
	int y;
} offset[4]={{-2,1},{-2,-1},{2,-1},{2,1}};

void HERO::update()
{
	canvas(x,y)<<bitmaps[dis*frames+f].mask();
	if (++f>=frames) f=0;
	x+=offset[dis].x,y+=offset[dis].y;
	if (++step>=30) {
		step=0;
		if (++dis>=4) dis=0;
	}
}

void draw_map(int xx,int yy)
{
	int i,j,sx,x,y;
	int start_x,start_y,end_x,end_y,block_x,block_y;
	end_x=xx+WIDTH,end_y=yy+HEIGHT;
	block_x=DIV(xx,64);
	block_y=DIV(yy,32)*2;
	start_x=block_x*64;
	start_y=block_y*16;
	for (sx=32,y=-16+start_y,i=block_y;y<end_y;y+=16,sx=32-sx,i++) {
		for (x=start_x-sx,j=block_x;x<end_x;x+=64,j++) {
			canvas(x,y)<<tile[map[MOD(j,256)][MOD(i,256)]].mask();
		}
	}
}

int wsMain(HDC hDC)
{
	static x=0,y=0;
	int sx,sy;

	int i,j;
	static alpha=0;
	if (iswalk) {
		static p=0;
		canvas.move(offset[dis].x,offset[dis].y);
		x+=offset[dis].x,y+=offset[dis].y;
		canvas.change();
		canvas(x+WIDTH/2-30,y+HEIGHT/2-80)<<walk[dis][p].trans(128).mask();
		if (++p>=14) p=0;
	}
	else {
		static p=0;
		if (p&1) canvas.change();
		else canvas.unchange();
		canvas(x+WIDTH/2-30,y+HEIGHT/2-80)<<stand[dis][p/2].trans(128).mask();
		if (++p>=16) p=0;
	}
	for (i=0;i<4;i++)
		npc[i]->update();
	canvas.unchange();
	draw_map(x,y);
	canvas.Blit2DC(hDC,0,0);
	return 0;
}

// Ϣѭ
static long FAR WINAPI WindowProc(HWND hWnd,UINT message, 
                           WPARAM wParam,LPARAM lParam )
{
    switch(message)
    {
		case WM_KEYDOWN: {
			switch (wParam) {
//			case VK_SPACE: iswalk=1-iswalk;
//				break;
			case VK_END: dis=0;
				iswalk=1;
				break;
			case VK_HOME: dis=1;
				iswalk=1;
				break;
			case VK_PRIOR: dis=2;
				iswalk=1;
				break;
			case VK_NEXT: dis=3;
				iswalk=1;
				break;
			case VK_UP: canvas.reset(++fps);
				break;
			case VK_DOWN: canvas.reset(--fps);
				break;
			case VK_SPACE: if (fps<=0) canvas.reset(fps=32);
				else canvas.reset(fps=0);
				break;
			}
			break;
		}
		case WM_KEYUP: {
			iswalk=0;
		}
		case WM_PAINT:
			if (inited) canvas.Update2DC(hDC,0,0);
			break;
        case WM_CREATE:
            break;
		case WM_CLOSE:
        case WM_DESTROY:
		    PostQuitMessage(0);
			return 0;
            break;
    }
    return DefWindowProc(hWnd,message,wParam,lParam);
} 

int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine,int nCmdShow)
{
    MSG         msg;
	HWND		hWnd;
	WSERR		e;

	init(hInstance);

	hWnd=create_window(hInstance);
	hDC=GetDC(hWnd);
	show_window(hWnd,WIDTH,HEIGHT,nCmdShow);
	GRAPH::init(hDC);
	int i,j,s;
	TRACEINFO("Test");
	TRACEINFO("ok");
	COLOR c(0x01020304);
	s=sizeof(COLOR);


	DATAFILE f;
//	f.load("sm.bmp");
//	e=back.load(f);
//	TRACEINFO(e);
//	f.load("hero.bmp");
//	e=bmp.load(f);
//	TRACEINFO(e);
	f.load("tile1.bmp");
	tile[0].load(f);
	f.load("tile2.bmp");
	tile[1].load(f);
//	f.load("sm.bmp");
//	sm.load(f);
	for (i=0;i<256;i++)
		for (j=0;j<256;j++)
			map[i][j]=rand()&1;
	f.load("stand.bmp");
	hero_stand.load(f);
	for (i=0;i<4;i++)
		for (j=0;j<8;j++)
			stand[i][j]=hero_stand(j*48,i*80,48,80);
	f.load("walk.bmp");
	hero_walk.load(f);
	for (i=0;i<4;i++)
		for (j=0;j<14;j++)
			walk[i][j]=hero_walk(j*48,i*80,48,80);
	npc[3]=new HERO(walk[0],14,100,100);
	npc[2]=new HERO(walk[0],14,200,200);
	npc[1]=new HERO(walk[0],14,300,300);
	npc[0]=new HERO(walk[0],14,400,400);

	canvas.reset(32);
//	canvas2.move(10,10);
	canvas=0;
//	canvas.move(0,200);
//	back<<bmp.trans(255);


//	canvas.draw(back,LOCATE(0,0),true);
/*
	TRACEINFO(bmp);
	for (i=0;i<canvas.col*canvas.row;i++)
		canvas.block[i]=i&1?0xff0000:0x00ff00;
//	canvas.block[13*15+1]=0xff0000;
*/

//	BMP kkk(100,100,16);
//	kkk(10,10);
//	kkk(10,10,100,100);

//	BMP16 bmp3=*(BMP16*)(*bmp)->subbmp(20,20,100,100);
//	bmp3[0][0]=0;

//	SUBBMP bmp2(bmp,-10,-10,40,40);
//	BMP16 b1(100,100),b2(100,100);
//	b1&=b2;
	inited=true;
	for (;;)
    {
        if(PeekMessage(&msg,NULL,0,0,PM_NOREMOVE))
        {
            if(!GetMessage(&msg,NULL,0,0))
            {
                return msg.wParam;
            }
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
        else {
			static DWORD st=(DWORD)-1;
			DWORD time;
			// Ϸѭ
			TIMER::timer(0);
			if (wsMain(hDC)) {
			    PostQuitMessage(0);
				return  0;
			}
//			time=TIMER::timer(1);
//			if (time<st) {
//				st=time;
//				time=TIMER::CyclePerSec/time/8;
//				TRACEVAR(time);
//			}
		}
/*
		else
        {
            WaitMessage();
        }
*/
    }
} 
